package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class MainPage extends PageBase {
    //Mapping
    By usernameLoginInfoTextArea = By.xpath("//div[@class='zh-header-info']");
    By reportIssueLink = By.xpath("//a[@href='/bug_report_page.php']");
    By menuPrincipal = By.xpath("//div[@class='bars']");
    By displayPagamentosVencidos = By.xpath("//span[text() = 'Pagamentos - Vencidos']");
    By menuDocumentosFiscais = By.xpath("//span[text() = 'Documentos Fiscais']");
    By menuDocumentosFiscais_Saidas = By.xpath("//span[text() = 'Saídas']");
    By menuDocumentosFiscais_Saidas_Lancamentos = By.xpath("//span[text() = 'Lançamentos']");
    By menuDocumentosFiscais_Saidas_Lancamentos_LancamentoDeSaida = By.xpath("//span[text() = 'Lançamento de Saída']");
    By menuDocsFiscaisEntrada = By.xpath("//span[text() = 'Entradas']");
    By menuDocsFiscaisEntradaLanc = By.xpath("//span[text() = 'Lançamentos']");
    By menuDocsFiscaisEntradaLanc_LancEntrada = (By.xpath("//span[text() = 'Lançamento de Entrada']"));
    By loadingWait = By.xpath("//*[@class='zh-background-loading ng-scope']//span[@class='zh-loading-icon']");
    By abrirSwipeNfEntradaPendente = By.xpath("//span[text() = 'Pendente']");
    By excluirNfEntrada = By.xpath("//li[@data-zh-id='1672551012283724483737']//div[@class='zh-test-box']");
    By popupSim = By.xpath("//span[text() = 'Sim']");
    By msgNfExcluidaComSucesso = By.xpath("//span[@class='notification-message-icon']");
    By sair = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li[2]/ul/li[3]/span");
    By menuParametricacao = By.xpath("//span[text() = 'Parametrização']");
    By menuParametricacao_DocumentosFiscais = By.xpath("//*[@data-zh-id='90884303611041170025330']//span[text() = 'Documentos Fiscais']");
    By menuParametricacao_DocumentosFiscais_Entrada = By.xpath("//span[text() = 'Documentos Fiscais de Entrada']");
    By menuParametricacao_DocumentosFiscais_Entrada_Integracao = By.xpath("//span[text() = 'Integração']");
    By menuParametricacao_DocumentosFiscais_Entrada_Integracao_RelacionamentoProdForn = By.xpath("//span[text() = 'Relacionamento de Produto X Produto (Arquivo XML)']");
    By selecionaProdAgua = By.xpath("//span[text() = '07Z917901A00']");
    By selecionaProdHela = By.xpath("//span[text() = '00A103800000']");
    By btnExcluirRelac = By.xpath("//li[@data-zh-id='1631753951640592399753']//div[@class='zh-test-box']");
    By capturaNrLanctoNf = By.xpath("//div[@class='body-content']//*[@data-zh-field-name='NRLANCTONF']//span");

    //teste importacao
    By menuDocsFiscaisEntradaLanc_Importacao = (By.xpath("//span[text() = 'Importação/Consulta de Notas Fiscais (Arquivo XML)']"));
    //Actions
    public String retornaUsernameDasInformacoesDeLogin() {return getText(usernameLoginInfoTextArea);}

    public void clicarEmReportIssue(){
        click(reportIssueLink);
    }
    public void clicarEmMenuPrincipal() {
        waitForElement(displayPagamentosVencidos);
        waitForElement(usernameLoginInfoTextArea);
        click(menuPrincipal);
    }
    //Menu
    public void clicarEmDocumentosFiscais(){
        click(menuDocumentosFiscais);
    }
    public void clicarEmDocumentosFiscaisSaidas(){
        click(menuDocumentosFiscais_Saidas);
    }
    //Lançamento de Saida
    public void clicarEmDocumentosFiscaisSaidasLancamentos(){
        click(menuDocumentosFiscais_Saidas_Lancamentos);
    }
    public void clicarEmDocumentosFiscaisSaidasLancamentosLancamentoDeSaida(){
        click(menuDocumentosFiscais_Saidas_Lancamentos_LancamentoDeSaida);
    }
    //Lançamento de Entrada
    public void clickDocsFiscaisEntrada(){
        click(menuDocsFiscaisEntrada);
    }
    public void clickDocsFiscaisEntradaLanc(){
        click(menuDocsFiscaisEntradaLanc);
    }
    public void clickDocsFiscaisEntrada_LancEntrada(){
        waitForVisibilityOfElementLocated(menuDocsFiscaisEntradaLanc_LancEntrada);
        click(menuDocsFiscaisEntradaLanc_LancEntrada);
    }
    //Excluir NF entrada
    public void clickBotaoExcluirNfEntrada(){
        click(excluirNfEntrada);
        waitForVisibilityOfElementLocated(popupSim);
        click(popupSim);
        waitForVisibilityOfElementLocated(msgNfExcluidaComSucesso);
    }
    public void clickParametrizacao(){
        click(menuParametricacao);
    }
    public void clickDocsFiscais(){
        ScrollToElementJavaScript(menuParametricacao_DocumentosFiscais);
        click(menuParametricacao_DocumentosFiscais);
    }
    public void clickDocFiscaisEntrada(){
        click(menuParametricacao_DocumentosFiscais_Entrada);
    }

    public void clickIntegracao(){click(menuParametricacao_DocumentosFiscais_Entrada_Integracao);
    }

    public void clickRelacProdForn(){
        click(menuParametricacao_DocumentosFiscais_Entrada_Integracao_RelacionamentoProdForn);
    }

   /* public void searchRelacProdForn(String fornecedor){click(procuraFornecedorRelac);
    sendKeys(procuraFornecedorRelac, fornecedor);}

    public void selecionaFornecedorRelac() {click(selecionaFornecedorRelac);}

    public void clicarAplicarFiltro() {click(aplicarFiltroRelacProdForn);}*/

    public void clickProdAgua(){
        click(selecionaProdAgua);
    }
    public void clickProdHela(){
        click(selecionaProdHela);
    }

    public void excluirRelac(){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(btnExcluirRelac);
    }
    public void popupSim(){
        click(popupSim);
    waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarEmMenuPrincipalDeLancEntrada(){
        click(menuPrincipal);
    }
    public String capturaNrLanctoNf(){
        return getText(capturaNrLanctoNf);
    }
    public void menuSair () {
        ScrollToElementJavaScript(sair);
        click(sair);
    }
    public void menuSairPopup () {click(popupSim);
    }

    public void clickDocsFiscaisEntrada_Importacao(){
        waitForVisibilityOfElementLocated(menuDocsFiscaisEntradaLanc_Importacao);
        click(menuDocsFiscaisEntradaLanc_Importacao);
    }

}