package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LancamentoSaidaFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.LancamentoSaidaPage;
import com.javaseleniumtemplate.pages.LoginPage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class LancamentoNotasTests extends TestBase {

    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    LancamentoSaidaFlows lancamentoSaidaFlows;
    LancamentoSaidaPage lancamentoSaidaPage;

    @Test
    public void efetuarLancamentoNotaComSucesso(){
        //Objects instances
        mainPage = new MainPage();

        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        lancamentoSaidaFlows = new LancamentoSaidaFlows();
        lancamentoSaidaPage = new LancamentoSaidaPage();

        //Parameteres

        String status = "Todos";
        String remetente = "Todos";
        String unidade = "HELA INGREDIENTES BRASIL";
        String serie = "SERIE 1";
        String dataSaida = "23/06/2022";
        String nomeProduto = "Geflugelbruhe Paste";
        String nomeProdutoDois = "Hela Ox Bouillon Paste Clear KG";
        String nomeProdutoTres ="Hela Cream Of Lobster Soup Paste Instant KG";
        String quantidadeProduto = "1";
        String valorProduto = "1";
        String statusEsperado = "Pendente";

        loginFlows.efetuarLogin();
        mainFlows.navegarParaLancamentoDeSaida();
        lancamentoSaidaFlows.aplicarFiltro(status,unidade,remetente,serie);
        lancamentoSaidaPage.clicarAdicionarLancamento();
        lancamentoSaidaPage.clicarPesquisaDestinatario();
        lancamentoSaidaPage.clicarEscolherDestinatario();
        lancamentoSaidaPage.clicarPesquisaSerie();
        lancamentoSaidaPage.preencherDataSaida(dataSaida);
        lancamentoSaidaPage.salvarLancamento();
        lancamentoSaidaPage.produtosMenu();
        lancamentoSaidaFlows.lançarProduto(nomeProduto, quantidadeProduto, valorProduto);
        lancamentoSaidaFlows.lançarProdutoDois(nomeProdutoDois, quantidadeProduto, valorProduto);
        lancamentoSaidaFlows.lançarProdutoTres(nomeProdutoTres, quantidadeProduto, valorProduto);
        lancamentoSaidaPage.clicarFecharLancamento();
        lancamentoSaidaPage.clicarConfirmarFecharLancamento();

        String statusAtual = lancamentoSaidaPage.retornarStatusLancamento();

        Assert.assertEquals(statusAtual,statusEsperado);
    }
}
