package com.javaseleniumtemplate.utils;

import java.sql.*;
import java.util.ArrayList;

import static com.javaseleniumtemplate.GlobalParameters.*;


public class DBUtils {

    public static ArrayList<String> getQueryResult(String query) {
        ArrayList<String> arrayList = null;
        Connection connection = null;

        try {
            Class.forName(DB_FOR_NAME);
            Statement stmt = null;
            connection = DriverManager.getConnection(DB_STRING_CONEXAO, DB_USER, DB_PASSWORD);

            stmt = connection.createStatement();
            ResultSet rs = stmt.executeQuery(query);

            if (!rs.isBeforeFirst()) {
                return null;
            } else {
                int numberOfColumns;
                ResultSetMetaData metadata = null;

                arrayList = new ArrayList<String>();
                metadata = rs.getMetaData();
                numberOfColumns = metadata.getColumnCount();

                while (rs.next()) {
                    int i = 1;
                    while (i <= numberOfColumns) {
                        arrayList.add(rs.getString(i++));
                    }
                }
            }

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                connection.close();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
        return arrayList;
    }

    public static void executeQuery(String query) {
        Connection connection = null;

        try {
            Class.forName(DB_FOR_NAME);
            Statement stmt = null;
            connection = DriverManager.getConnection(DB_STRING_CONEXAO, DB_USER, DB_PASSWORD);

            stmt = connection.createStatement();
            stmt.executeQuery(query);
            connection.commit();

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                connection.close();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }
}
